
;Random character generator test program
;by: dedndave

;--------------------------------------------------------------------------

        include    masm32rt.inc

;--------------------------------------------------------------------------

        .data

RandString  db 0,0

        .data?

StdInHndl   dd ?
EventCount  dd ?

;the INPUT_RECORD structure is a union of several other structure types
;only the KeyEvent structure is shown here for simplicity

InpEvntRec INPUT_RECORD <>
; .EventType                  dw ?
;  (alignment)                dw ?
; .KeyEvent.bKeyDown          dd ?
; .KeyEvent.wRepeatCount      dw ?
; .KeyEvent.wVirtualKeyCode   dw ?
; .KeyEvent.wVirtualScanCode  dw ?
;      UNION
; .KeyEvent.UnicodeChar       dw ?
; .KeyEvent.AsciiChar         db ?
;      ENDS
; .KeyEvent.dwControlKeyState dd ?

        .code
        .586

;--------------------------------------------------------------------------

        OPTION  PROLOGUE:NONE
        OPTION  EPILOGUE:NONE

_main   proc

        INVOKE  GetStdHandle,
                STD_INPUT_HANDLE
        mov     StdInHndl,eax

RTest0: call    Randm
        mov     edi,offset RandString
        mov     [edi],al
        print   edi
        call    InKey
        jz      RTest0

        exit

_main   endp

;--------------------------------------------------------------------------

Randm   PROC

;Random ASCII character generator
;generates numbers 0-9 and letters a-z (lower case)

;Call With: Nothing

;  Returns: eax = al = pseudo-random ASCII character

        INVOKE  Sleep,0
        sub     esp,8
        INVOKE  QueryPerformanceCounter,esp
        pop     eax
        xor     eax,[esp]
        add     esp,4
        xor     edx,edx
        mov     ecx,36
        div     ecx
        xchg    eax,edx
        add     eax,30h
        cmp     al,39h
        jbe     Randm0

        add     eax,27h

Randm0: ret

Randm   ENDP

;--------------------------------------------------------------------------

InKey   PROC

InKey0: INVOKE  PeekConsoleInput,
                StdInHndl,
                offset InpEvntRec,
                1,
                offset EventCount
        mov     eax,EventCount
        or      eax,eax
        jz      InKey1

        INVOKE  ReadConsoleInput,
                StdInHndl,
                offset InpEvntRec,
                1,
                offset EventCount
        movzx   eax,InpEvntRec.EventType
        dec     eax
        jnz     InKey0

        dec dword ptr InpEvntRec.KeyEvent.bKeyDown
        jnz     InKey0

        inc     eax
        movzx   eax,InpEvntRec.KeyEvent.wVirtualScanCode

InKey1: ret

InKey   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------

        end     _main
